﻿Option Strict On
Imports Microsoft.Reporting.WinForms

Public Class MeinErsterReport

    Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        Aktualisieren()
        Me.prtReportViewer.RefreshReport()
        Me.prtReportViewer.RefreshReport
    End Sub
    Private Sub prtReportViewer_ReportRefresh(sender As System.Object, e As System.ComponentModel.CancelEventArgs) Handles prtReportViewer.ReportRefresh
        Aktualisieren()
    End Sub

    Private Sub Aktualisieren()
        Me.SuspendLayout()
        'Berichtsparameter an den Report übergeben
        Dim pAlter As New ReportParameter("rpAlter", nudAlter.Value.ToString)
        Dim pVorName As New ReportParameter("rpVorName", tbxVorname.Text)
        Dim pNachName As New ReportParameter("rpNachName", tbxNachName.Text)
        With prtReportViewer
            .LocalReport.ReportEmbeddedResource = "ReportViewerTutorial.Report_MeinErsterBericht.rdlc"
            .LocalReport.SetParameters(New ReportParameter() {pAlter, pVorName, pNachName}) ' Parameterübergabe
            .RefreshReport()
        End With
        Me.ResumeLayout()
    End Sub

    Sub Aktualisieren(Werte As List(Of String))
        Me.SuspendLayout()
        Dim pParameter As New ReportParameter("rpMehrereWerte", Werte.ToArray) ' Parameter als Array übergeben
        With prtReportViewer
            .LocalReport.ReportEmbeddedResource = "ReportViewerTutorial.Report_ParameterArray.rdlc"
            .LocalReport.SetParameters(New ReportParameter() {pParameter}) ' Parameterübergabe
            .RefreshReport()
        End With
        Me.ResumeLayout()
    End Sub

End Class